declare const UNSUPPORTED_CALL_SIGNATURE_ERROR: string;
declare const TARGET_MUST_BE_A_FUNCTION: string;
interface ProfileOptions {
    custom: any;
}
declare function profile<T extends Function>(fn: T, label: string, options: ProfileOptions): T;
declare function profile<T extends Function>(fn: T, options: ProfileOptions): T;
declare function profile<T extends Function>(fn: T, label: string): T;
declare function profile<T extends Function>(fn: T): T;
declare function profile(label: string, options: ProfileOptions): (target: any, propertyKey: string, descriptor: PropertyDescriptor) => PropertyDescriptor;
declare function profile(options: ProfileOptions): (target: any, propertyKey: string, descriptor: PropertyDescriptor) => PropertyDescriptor;
declare function profile(label: string): (target: any, propertyKey: string, descriptor: PropertyDescriptor) => PropertyDescriptor;
declare function profile(): (target: any, propertyKey: string, descriptor: PropertyDescriptor) => PropertyDescriptor;
interface State {
    enabled: boolean;
    listeners: Array<EventCallback>;
}
declare function getNextId(): number;
declare const state: State;
interface PerformanceEvent {
    id: number;
    fnName: string;
    label: string;
    duration: number;
    result: any;
    options?: ProfileOptions;
}
interface EventCallback {
    (event: PerformanceEvent): void;
}
declare function useProfilr(active: boolean): void;
declare function processEvent(event: PerformanceEvent): void;
declare function registerEventCallback(cb: EventCallback): () => void;
declare function isFunction(functionToCheck: any): boolean;
declare function isPromise(obj: any): boolean;
export { registerEventCallback, PerformanceEvent, EventCallback } 
export { profile, ProfileOptions } 